# Copyright 2012 Canonical Ltd.
"""Common fixtures for lp2kanban tests."""

__metaclass__ = type

from lp2kanban.kanban import Record


class FauxCardType:

    def __init__(self):
        self.id = 1
        self.name = "Test"
        self.is_default = True
        self.ColourHex = "#000"
        self.IconPath = None


class FauxBoard:

    def __init__(self, cards, users_by_id=None, default_cardtype=None):
        self.cards = cards
        self.users_by_id = users_by_id
        self.default_cardtype = default_cardtype or FauxCardType()
        self.cardtypes = {1: FauxCardType()}

class FauxLane:

    def __init__(self, path=None, id=None, type=None, board=None):
        self.id = id or 1
        self.type = type
        self.board = board or FauxBoard("Test")
        self.path = path
        self.next_lanes = None

    def getNextLanes(self):
        return self.next_lanes

    def addNextLane(self, lane):
        if self.next_lanes is None:
            self.next_lanes = [lane]
        else:
            self.next_lanes.append(lane)


class FauxCard:

    def __init__(self, external_card_id=None, title=None,
                 description_annotations=None, lane=None,
                 assigned_user_id=None, external_system_name=None,
                 external_system_url=None):
        self.external_card_id = external_card_id
        self.title = title
        self.description_annotations = description_annotations or Record()
        self.lane = lane
        self.assigned_user_id = assigned_user_id
        self.external_system_name = external_system_name
        self.external_system_url = external_system_url

    def save(self):
        """A no-op for compatibility."""
        return


class FauxLeankitUser:

    def __init__(self, id, user_name=None, full_name=None, email_address=None):
        self.id = id
        self.user_name = user_name
        self.full_name = full_name
        self.email_address = email_address


class FauxLaunchpadUser:

    def __init__(self, name, display_name=None):
        self.name = name
        self.display_name = display_name


class FauxLaunchpadUsersForBoard:

    def __init__(self, kanban_to_lp=None, lp_to_kanban=None):
        self.kanban_to_lp = kanban_to_lp
        self.lp_to_kanban = lp_to_kanban
